#!/usr/bin/env python

from Tkinter import *
import test_de_sala
import xml.sax._exceptions
xmlerrores = xml.sax._exceptions

class Vision:
    def __init__(self):
        
        #Contruimos el interfaz grfico
        self.r=Tk()
        self.r.minsize(400,460)
        self.r.rowconfigure(0, weight=1)
        self.r.columnconfigure(0, weight=1)
        self.r.columnconfigure(1, weight=2)
        self.titulo=Label(self.r,text='SalaTester v0.2 para Min, de Aranarth')
        self.titulo.pack(side=TOP)
        self.t=Entry(self.r,width=30)
        self.t.pack(side=TOP)
        Button(self.r,text='Mostrar',command=self.busca).pack(side=TOP)
        self.res=Label(self.r,text='Sin datos')
        self.res.pack(expand=0,side=TOP)

    def run(self):
        self.r.mainloop()

    def busca(self):
        id=self.t.get()
        
        try:
            sala=test_de_sala.Sala(id)

            texto01 = "Cargada sala con id: "+sala.id
            texto02 = "Nombre: "+sala.nombre
            texto03 = "Autor: "+sala.autor
            texto04 = "rea: "+sala.area
            texto05 = "Versin: "+sala.version
            texto06 = "Comentario: "+sala.comentario

            textotemp = "\n"
            for item in sala.descripcion:
                textotemp+='dificultad %d: %s...\n' % (item["dificultad"], item["texto"][:30])
            texto08 = "Descripciones:"+textotemp

            textotemp = "\n"
            for salida in sala.salidas:
                textotemp+='%s: %s, %s, %s\n' % (salida["direccion"], salida["dificultad"],
                                              salida["id"], salida["descripcion"])

            texto09 = "Salidas:"+textotemp

            texto10 = "Propiedades:\n"+'Volumen: '+str(sala.volumen)+' Luz: '+str(sala.luz)+' Aura: '+str(sala.aura)+'\n'+\
                      'Combate: '+sala.combate+' Ocultabilidad: '+str(sala.ocultabilidad)+'\n'

            textotemp = '\n'
            for objeto in sala.objetos:
                textotemp += '%s: %d, %d, %d, %d, %s\n' % (objeto["id"], objeto["cantidad"], objeto["maximo"],
                                                          objeto["probabilidad"], objeto["dificultad"], 
                                                          objeto["descripcion"])
            texto11 = "Objetos:"+textotemp

            textotemp = '\n'
            for encuentro in sala.encuentros:
                textotemp += '%s: %d, %d, %d, %d, %s\n' % (encuentro["id"], encuentro["cantidad"],
                                                  encuentro["maximo"], encuentro["probabilidad"],
                                                  encuentro["dificultad"], encuentro["descripcion"])

            texto12 = "Encuentros:"+textotemp
                    
            textofinal = texto01+'\n'+texto02+'\n'+texto03+'\n'+texto04+'\n'\
                         +texto05+'\n'+texto06+'\n'+texto08+'\n'+texto09+'\n'\
                         +texto10+'\n'+texto11+'\n'+texto12
                


            self.res.configure(text=textofinal,justify=LEFT)

        except IOError:

            self.res.configure(text="No se ha encontrado el archivo con id:\n\n"+id,justify=LEFT)
        except xmlerrores.SAXParseException, mensaje_error:
            self.res.configure(text="El fichero que intentabas abrir tiene un error sintctico \nen la lnea "+str(mensaje_error._linenum)+', carcter '+str(mensaje_error._colnum)+". Por favor, revsalo.",justify=LEFT)

        except:
            error = sys.exc_type
            mensaje_error = sys.exc_value
            self.res.configure(text="El fichero con id "+id+" existe pero provoca un error extrao.\nLo que s podemos decir es que el error no es sintctico\n(o no es el principal error)\n"+error+'\n'+mensaje_error,justify=LEFT)            

        self.res.pack(anchor=W)

if __name__=='__main__':
    #OJO: Este mdulo slo se importa si se va a usar

    agtk=Vision()
    agtk.run()
